#ifndef STA_CORE_PRINTABLE_SERIAL_HPP
#define STA_CORE_PRINTABLE_SERIAL_HPP

#include <sta/debug/printing/printable.hpp>
#ifdef STA_PLATFORM_ARDUINO

namespace sta
{
    class PrintableSerial: public Printable
    {
    public:
        /**
         * @brief Construct a new Printable Serial object
         */
        PrintableSerial(unsigned long baud);

        /**
         * @brief Print string.
         *
         * @param str       String buffer
         * @param length    String length
         */
        void print(const char * str, size_t length) override;
    };
} // namespace sta

#endif // STA_PLATFORM_ARDUINO

#endif // STA_CORE_PRINTABLE_SERIAL_HPP