#include <sta/debug/printing/printable_uart.hpp>

#include <sta/debug/assert.hpp>
#include <sta/printf.hpp>

#ifdef STA_PLATFORM_ARDUINO
#   include <inttypes.h>
#   include <string.h>
#else
#   include <cinttypes>
#   include <cstring>
#endif // STA_PLATFORM_ARDUINO


namespace sta
{
    
    PrintableUART::PrintableUART(UART * intf)
        : intf_{intf}
    {
        STA_ASSERT(intf != nullptr);
        STA_ASSERT(intf->settings().mode == UARTMode::RX || intf->settings().mode == UARTMode::RX_TX);
    }

    void PrintableUART::print(const char * str, size_t length)
    {
        intf_->transfer(reinterpret_cast<const uint8_t *>(str), length);
    }

} // namespace sta
